package intermediate;

import java.util.ArrayList;
import java.util.Stack;

import util.Terminal;

public class Generator {
	FunctionTable f;
	SymbolTable s;
	Stack<Integer> ss;
	Terminal belataklif;
	Stack<Function> callee=new Stack<Function>();
	Stack<Integer> calleeCounter=new Stack<Integer>();
	Stack<Integer> scopeStack=new Stack<Integer>();
	int counter=2;
	int tmpVar=500; 
	
	Stack<Terminal> opStack; 
	Stack<String> typeStack;
	
	int getTemp(String type)
	{
		int loc=tmpVar;
		if (type.equals("int"))
			tmpVar++;
		if (type.equals("double"))
			tmpVar+=2;
		return loc;
	}
	
	public Generator() {
		ss=new Stack<Integer>();
		opStack=new Stack<Terminal>();
		typeStack=new Stack<String>();
		f=new FunctionTable();
		s=new SymbolTable();
	}
	
	
	
	String PB[]=new String[100];
	public void generate(String action,Terminal current){
		if(action.equals("#pid")){
			for(int i=s.variables.size()-1;i>=0;i--){
				if(s.variables.get(i).name.equals(current.type)){
					ss.push(s.variables.get(i).address);
					return;
				}
			}
			System.out.println("ID "+ current.type +" was not declared.");
		}else if (action.equals("#assign")){
			PB[counter]=counter+": (=,"+ss.get(ss.size()-1)+","+ss.get(ss.size()-2)+",)";
			ss.pop();
			ss.pop();
			if (!typeStack.get(typeStack.size()-1).equals(typeStack.get(typeStack.size()-2)))
			{
				if (typeStack.get(typeStack.size()-1).equals("void"))
					System.err.println("Assignmet's types don't match.");
				else if (typeStack.get(typeStack.size()-2).equals("int"))
					System.err.println("Assignmet's types don't match.");
				else
					System.err.println("Warnging, casting int to double in assignment.");
			}
			typeStack.pop();
			typeStack.pop();
			counter++;
		}else if (action.equals("#save")){
			ss.push(counter);
			counter++;
		}else if(action.equals("#save_jmp")){
			int temp=counter+1;
			PB[ss.get(ss.size()-1)]=ss.get(ss.size()-1)+": (jpf,"+ss.get(ss.size()-2)+",#"+temp+",)";
			ss.pop();
			ss.pop();
			ss.push(counter);
			counter++;
		}else if (action.equals("#jmp")){			
			PB[ss.get(ss.size()-1)]=ss.get(ss.size()-1)+": (jp,#"+counter+", ,)";
			ss.pop();
		}else if (action.equals("#Poper")){
			opStack.push(current);
		}else if (action.equals("#while")){
			int temp=counter+1;
			PB[ss.get(ss.size()-1)]=ss.get(ss.size()-1)+": (jpf,"+ss.get(ss.size()-2)+",#"+temp+",)";
			PB[counter]=counter+": (jp,#"+ss.get(ss.size()-3)+", ,)";
			counter++;
			ss.remove(ss.size()-1);
			ss.remove(ss.size()-1);
			ss.remove(ss.size()-1);
		}else if(action.equals("#label")){
			ss.add(counter);
		}else if(action.equals("#set-id")){
			s.installId(current,typeStack.get(typeStack.size()-1),f,scopeStack.size(	));
		}else if(action.equals("#poptype")){
			typeStack.pop();
		}else if(action.equals("#ptype")){
			typeStack.push(current.name);
		}else if(action.equals("#belataklif")){
			belataklif=current;
		}else if(action.equals("#known-var")){
			s.installId(belataklif, typeStack.get(typeStack.size()-1),f,scopeStack.size());
		}else if (action.equals("#add") || action.equals("#mul")){
			int t=getTemp(typeStack.get(typeStack.size()-1));
			if (typeStack.get(typeStack.size()-1).equals("void") || typeStack.get(typeStack.size()-2).equals("void"))
			{
				System.err.println("Type void cannot be assigned.");
				typeStack.pop();
			}
			if (typeStack.get(typeStack.size()-1).equals("double") || typeStack.get(typeStack.size()-2).equals("double"))
			{
				typeStack.pop();
				typeStack.pop();
				typeStack.push("double");
			}
			else
			{
				typeStack.pop();
			}
			PB[counter]=counter+": (" + opStack.get(opStack.size()-1).getType() +","+ss.get(ss.size()-1)+","+ss.get(ss.size()-2)+"," + t +")";
			counter++;
			ss.pop();
			ss.pop();
			ss.push(t);
			opStack.pop();
		}else if (action.equals("#Pnum")){
			String type="int";
			for (int i=0; i<current.getType().length(); i++)
				if (current.getType().charAt(i)=='.')
					type="double";
			typeStack.push(type);
			int t=getTemp(type);
			PB[counter]=counter+": (=,#"+current.getType()+","+t+",)";
			ss.push(t);
			counter++;
		}else if (action.equals("#rel")){
			int t=getTemp("int");
			PB[counter]=counter+": (" + opStack.get(opStack.size()-1).getType() +","+ss.get(ss.size()-1)+","+ ss.get(ss.size()-2) +","+t+ ")";
			counter++;
			ss.pop();
			ss.pop();
			typeStack.pop();
			typeStack.pop();
			ss.push(t);
			opStack.pop();
		}else if (action.equals("#buildFunc")){
			Function func=new Function();
			func.name=belataklif.type;
			func.Type=typeStack.get(typeStack.size()-1);
			typeStack.pop();
			func.address=counter;
			if (!func.Type.equals("void"))
			{
				func.ret.address=getTemp(func.Type);
				func.ret.Type=func.Type;
			}
			func.savedAddress.address=getTemp("int");
			func.savedAddress.Type="int";
			func.args=new ArrayList<Variable>();
			for (int i=0; i<f.functions.size(); i++)
				if (f.functions.get(i).name.equals(func.name))
				{
					System.err.println("Function "+func.name+" has been declared more than once.");
					return;
				}
			int ending=s.variables.size();
			if (scopeStack.size()>0)
				ending=scopeStack.get(0);
			for (int i=0; i<ending; i++)
				if (s.variables.get(i).name.equals(func.name))
				{
					System.err.println("Previous non-function declaration of " +func.name+ "." );
				}
			f.functions.add(func);
		}else if (action.equals("#addParam")){
				Variable var=new Variable();
				var.address=s.installId(current,typeStack.get(typeStack.size()-1),f,scopeStack.size());
				var.Type=typeStack.get(typeStack.size()-1);
				typeStack.pop();
				f.functions.get(f.functions.size()-1).args.add(var);
		}else if (action.equals("#PvarBelataklif")){
			for(int i=s.variables.size()-1;i>=0;i--){
				if(s.variables.get(i).name.equals(belataklif.type)){
					ss.push(s.variables.get(i).address);
					typeStack.push(s.variables.get(i).Type);
					return;
				}
			}
			ss.push(-1);
			typeStack.push("int");
			System.err.println("ID "+ belataklif.type +" was not declared.");
		}else if (action.equals("#PfuncBelataklif")){
			//TODO
			for (int i=0; i<f.functions.size(); i++)
				if (f.functions.get(i).name.equals(belataklif.type))
				{
					callee.push(f.functions.get(i));
					calleeCounter.push(0);
					return;
				}
			callee.push(new Function());
			calleeCounter.push(0);
			System.err.println("The function "+ belataklif.type+" is not declared.");
		}else if (action.equals("#setParam")){
			Function func=callee.get(callee.size()-1);
			int index=calleeCounter.get(calleeCounter.size()-1);
			if (func.args.size()<=index)
			{
				System.err.println("too many arguments in function call for "+func.name+".");
			}
			if (!func.args.get(index).Type.equals(typeStack.get(typeStack.size()-1)) )
			{
				if (func.args.get(index).Type.equals("int") || typeStack.get(typeStack.size()-1).equals("void"))
					System.err.println("Wrong Argumet type in function call for "+func.name+".");
				else if (func.args.get(index).Type.equals("double"))
				{
					System.err.println("Warning, casting int to double in function "+func.name+".");
				}
			}
			PB[counter]=counter+": (=,"+ss.get(ss.size()-1)+","+func.args.get(index).address+",)";
			calleeCounter.set(calleeCounter.size()-1, calleeCounter.get(calleeCounter.size()-1)+1);
			typeStack.pop();
			ss.pop();
			counter++;
		}else if (action.equals("#setSavedAddress")){
			int tempo=counter+2;
			Function func=callee.get(callee.size()-1);
			PB[counter]=counter+": (=,"+tempo+","+func.savedAddress.address+",)";
			counter++;
			PB[counter]=counter+": (jp,#"+func.address +", ,)";
			counter++;
			ss.push(callee.get(callee.size()-1).ret.address);
			typeStack.push(callee.get(callee.size()-1).Type);
			if (callee.get(callee.size()-1).args.size()!=calleeCounter.get(callee.size()-1))
				System.err.println("too few arguments in function call for "+func.name+".");
		}else if (action.equals("#jmpToSavedAddress")){
			Function func=f.functions.get(f.functions.size()-1);
			PB[counter]=counter+": (jp,"+func.savedAddress.address +", ,)";
			counter++;
		}else if(action.equals("#popSS")){
			typeStack.pop();
			ss.pop();					
		}else if (action.equals("#Pint")){
			typeStack.push("int");
		}else if (action.equals("#Pdouble")){
			typeStack.push("double");
		}else if (action.equals("#Pvoid")){
			typeStack.push("void");
		}
		else if (action.equals("#pScope")){
			scopeStack.push(s.variables.size());
		}else if (action.equals("#popScope")){
			while(s.variables.size()>scopeStack.get(scopeStack.size()-1))
			{
				s.variables.remove(s.variables.size()-1);
			}
			scopeStack.pop();
		}else if (action.equals("#popCallee")){
			callee.pop();
			calleeCounter.pop();
		}else if (action.equals("#setMain")){
				for (int i=0; i<f.functions.size(); i++)
					if (f.functions.get(i).name.equals("main"))
					{
						Function main=f.functions.get(i);
						PB[0]=0+": (jp,#"+main.address +", ,)";
						PB[1]=1+": (=,#"+counter +","+ main.savedAddress.address +",)";
					}
				PB[counter]=counter+": STOP";
				counter++;
		}
		
		
	}
	
	public void print()
	{
		for (int i=0; i<counter; i++)
			System.out.println(PB[i]);
	}
}
