package parser;

import intermediate.Generator;

import java.util.Stack;

import javax.swing.text.DefaultEditorKit.PasteAction;

import scanner.Scanner;
import util.NonTerminal;
import util.Terminal;
import util.Token;

public class Parser {
	Scanner sc;
	Stack<Token> Pstack;
	ParsTable PTable;
	Rules PRules;
	Terminal lastToken;
	public Generator gen;
	public Parser(Scanner sc) {
		this.sc=sc;
		Pstack=new Stack<Token>();
		Pstack.push(new Terminal("$"));
		Pstack.push(new NonTerminal("Program"));
		PTable=new ParsTable();
		PTable.build();
		PRules=new Rules();
		gen=new Generator();
	}
	public void Pars(){
		lastToken=sc.getToken();
		while(true){
			if(lastToken.name.equals("eof") && Pstack.size()==1){
				break;
			}
			if(Pstack.elementAt(Pstack.size()-1).isTerminal==false){
				int ruleNumber=PTable.a[Pstack.elementAt(Pstack.size()-1).number][lastToken.number];
				if(ruleNumber==-2){ // khoone khali
					System.out.println("Pars Error: Unexpected <"+lastToken.name+","+lastToken.type+"> !");
					lastToken=sc.getToken();
					continue;
				}else if(ruleNumber==-1){//Sync
					System.out.println("Pars Error: Expected " + Pstack.pop().name+" !");
					continue;
				}
				Pstack.pop();
				Rule curRule=PRules.r.get(ruleNumber);
		//		System.out.println(curRule); 
				for(int i=curRule.RHS.size()-1;i>=0;i--){
					Pstack.push(curRule.RHS.get(i));
				}
			}else{
				Terminal tmp=(Terminal)Pstack.pop();
				if (tmp.name.equals("ActionSymbol"))
					gen.generate(tmp.type, lastToken);
				else
					Match(lastToken,tmp);
			}
			
		}
	}
	private void Match(Terminal temp, Terminal pop) {
		if(temp.name.equals(pop.name) && !(temp.name.equals("delim") && !temp.type.equals(pop.type))){
			lastToken=sc.getToken();
			return;
		}
		if(Pstack.size()>1){
			System.out.println("Pars Error: Expected <"+pop.name+","+pop.type+"> !");
		}else{
			Pstack.push(pop);
			lastToken=sc.getToken();
		}
	}
}
