package scanner;

import java.io.File;
import java.io.FileNotFoundException;

import util.Terminal;
import util.Useful;

public class Scanner {
	java.util.Scanner sc;
	String cur="";
	boolean iscomment=false;
	int lineNumber=0;
	public Scanner(String fileName) throws FileNotFoundException{

			sc=new java.util.Scanner(new File(fileName));
	}
	
	public Terminal getToken(){
		String temp="";
		Terminal ret=null;
		while(cur.length()==0){
			if(sc.hasNextLine()){
				cur=sc.nextLine();
				lineNumber++;
				cur=cur.trim();
				mytrim();
			}else{
				return new Terminal("$");
			}
		}
		cur=cur.trim();
		if(Useful.isdelim(cur.charAt(0))){
			temp=cur.substring(0,1);
			ret=new Terminal(cur.substring(0, 1));
			cur=cur.substring(1);
			return ret;
		}
		if(Useful.issign(cur.charAt(0))){
			if(cur.length()>1 && Useful.issign(cur.charAt(1))){
				temp=cur.substring(0,2);
				ret=new Terminal(cur.substring(0,2));
				cur=cur.substring(2);
			}else{
				temp=cur.substring(0,1);
				ret=new Terminal(cur.substring(0,1));
				cur=cur.substring(1);
			}
			if(check(temp)==true){
				return ret;
			}else{
				panic(temp);
				return getToken();
			}
		}
		for(int i=0;i<cur.length();i++){
				
				if(cur.charAt(i)==' ' || cur.charAt(i)=='\t'){
					temp=cur.substring(0,i);
					cur=cur.substring(i+1);
					break;
				}
				if(Useful.isdelim(cur.charAt(i)) || Useful.issign(cur.charAt(i))){
					temp=cur.substring(0,i);
					cur=cur.substring(i);
					break;
				}
				if(i==cur.length()-1){
					temp=cur;
					cur=new String("");
				}
		}
		ret=new Terminal(temp);
		if(check(temp)==true){
			return ret;
		}else{
			panic(temp);
			return getToken();
		}
	}

	private void panic(String temp) {
		System.out.println("LEXICAL ERROR at line"+lineNumber+"! " +temp+" is ignored!");
	}

	private boolean check(String s) {
		if(Useful.isnum(s.charAt(0))){
			boolean flag=false;
			int num=0;
			for(int i=0;i<s.length();i++){
				if(Useful.isnum(s.charAt(i))){
					continue;
				}
				if(s.charAt(i)!='.'){//gheyre ashar
					return false;
				}
				num++;
			}
			if(num>1){//2 ta gheyre adad bashe
				return false;
			}
			if(Useful.isnum(s.charAt(s.length()-1))==false){
				return false;
			}
		}else if(Useful.isalpha(s.charAt(0))){//wrong ID
			for(int i=0;i<s.length();i++){
				if( Useful.isalpha(s.charAt(i)) || Useful.isnum(s.charAt(i)) ){
					continue;
				}
				if(s.charAt(i)!='_'){
					return false;
				}
			}
		}else if(Useful.issign(s.charAt(0))){//Wrong operator
			if(s.length()>2){
				return false;
			}
			if(s.length()==2){
				if(s.charAt(1)!='='){
					return false;
				}
			}else{
				if(s.equals("!")){
					return false;
				}
			}
			
		}else if(Useful.isdelim(s.charAt(0)) == false){//not alpha, operator, number, delim
			return false;
		}
		return true;
	}

	private void mytrim() {
		for(int i=0;i<cur.length();i++){
			if(cur.charAt(i)!=' ' && cur.charAt(i)!='\t'){
				break;
			}
			if(i==cur.length()-1){
				cur="";
			}
		}
		if(iscomment==true){//finishing /*
			for(int i=0;i<cur.length();i++){
				if(cur.charAt(i)=='*' && cur.length()>i+1 && cur.charAt(i+1)=='/'){
					cur=cur.substring(i+2);
					iscomment=false;
					break;
				}
			}
			if(iscomment==true){
				cur="";
			}
		}
		for(int i=0;i<cur.length();i++){
			// line comment
			if(cur.charAt(i)=='/' && cur.length()>i+1 && cur.charAt(i+1)=='/'){
				cur=cur.substring(0,i);
				break;
			}
			if(cur.charAt(i)=='/' && cur.length()>i+1 && cur.charAt(i+1)=='*'){
				iscomment=true;
				for(int j=i+2;j<cur.length();j++){
					if(cur.charAt(j)=='*' && cur.length()>j+1 && cur.charAt(j+1)=='/'){
						cur=cur.substring(0,i).concat(cur.substring(j+2));
						i=0;
						iscomment=false;
						break;
					}	
				}
				if(iscomment==true){
					cur=cur.substring(0, i);
				}
			}
		}
		String temp=new String("");
		boolean ignore=false;
		for(int i=0;i<cur.length();i++){
			if(cur.charAt(i)==' ' || cur.charAt(i)=='\t'){
				if(ignore==false){
					ignore=true;
					temp+=' ';
				}
				continue;
			}
			ignore=false;
			temp+=cur.charAt(i);
		}
		cur=temp;
	}
}